%  estvar routine: estimate vector autoregression
%  The data are preliminary detracted the mean :
%  Detracted data substitute the input data
%  Estimates are computed by least squares 

function[rssq,U,P]=estvar(yi , m)

%   ............   INPUT  PARAMETERS
%  k - component series , n observations, m autoregressive order
%  Y data : each time series fills a row (k rows, n columns) 

Y = yi; [k, n] =  size(Y);

%   ............   OUTPUT  PARAMETERS
%  rssq(k,k) residual sum of squares 
%  U(k,n) multivariate residuals
%  P(k,k, m)  the m matrices (dimension k)of estimated coefficients  

clear S; clear U; clear P;

%   .........   subtract mean from data

      Y=Y-kron(ones(1,n),mean(Y,2));


%  ...........  LEAST SQUARES ESTIMATE OF VECTOR AUTOREGRESSION

 y=reshape(Y,k*n,1);
 Z=zeros(m*k,n);
 for j=m+1:n,
 for h=1:m,
 for i = 1:k, Z((h-1)*k +i,j)=Y(i,j-h);, end;
end;
end;
 p=(kron(((inv(Z*Z'))*Z),eye(k)))*y;
 P=reshape(p,k,k,m);

%  .............  RESIDUALS ESTIMATES AND VARIANCE COVARIANCE MATRIX

u=y-kron((Z'),eye(k))*p;
u(1:m*k,1)=zeros(m*k,1);
U=reshape(u,k,n);
%S=(U*U')./n;
%Sinv=inv(S)
rssq =  U*U';

clear y; clear Z; clear p; clear u;
clear i; clear j; clear h;

%%  estvar ends

 
 
 






